#include "movable.h"

#include <cstring>
#include <GL/gl.h>

void Movable::scale(float s)
{
    m_scale *= s;
}

void Movable::translate(float tx, float ty, float tz)
{
    m_translate += Vector3(tx, ty, tz);
}

void Movable::rotate(float deg, Vector3 v)
{
    Matrix rot = Matrix::fromRotation(deg, v);
    m_rotate *= rot;
}

void Movable::setRotation(double deg, const Vector3 &v)
{
    m_rotate = Matrix::fromRotation(deg, v);
}

void Movable::doTransforms(void) const
{
    glTranslatef(m_translate.x(), m_translate.y(), m_translate.z());
    glMultMatrixf(m_rotate.get());
    glScalef(m_scale, m_scale, m_scale);
}

void Movable::doMovement(double timestep)
{
    m_translate += m_velocity * timestep;
}
